from playwright.sync_api import Playwright, sync_playwright, expect

import re
import json
import cyaml
import crawler

#爬虫启动
def CrawlerBaidu(com_name,baike_url):
    with sync_playwright() as playwright:
        return GetBaiduCompany(playwright,com_name,baike_url)

#爬取百度的数据
def GetBaiduCompany(playwright: Playwright,com_name,baike_url) -> int:
    browser = playwright.chromium.launch(headless=cyaml.data[cyaml.data["env"]]["headless"])
    context = browser.new_context(viewport={"width": 800, "height": 600})
    page = context.new_page()
    name = com_name
    url = baike_url
    #获取需要爬取数据的公司
    crawler.Log("--------------------------baidu baike start--------------------------------")
    crawler.Log( "开始请求 " +name+ " 公司的百科地址，地址为：" + url)

    page.goto(url)
    all = page.locator(".lemma-summary").all_text_contents()
    intro = re.sub(r'\[[\d-]+\]', '', str(all))
    crawler.Log(name+" 公司的百科地址上抓取到的数据："+intro)
    if name != "" and intro != '[]':
        intro_new = str(intro[2:len(intro) - 2])
        new_string1 = re.sub(r'\\n', "", intro_new)
        new_string2 = re.sub(r'\\xa0', "", new_string1)

        name2 = crawler.SaveCompanyData(name, 1, new_string2)
        if name2 != "":
            crawler.Log(name2+" 公司百科数据回传到php 回传成功")
            return 100
        else:
            crawler.Log(name + "公司百科数据回传到php 回传失败")
            return 100
    else:
        crawler.SaveCompanyData(name, 1, "")
        crawler.Log(name +" 公司没有获取到百科数据回传到php 回传成功")
        return 100

    # ---------------------
    context.close()
    browser.close()
    return 100
