import crawler
import requests
from playwright.sync_api import Playwright, sync_playwright
import json
import cyaml

def spider_company(page,com_name,boss_url):
    company_nameO = com_name
    url = boss_url
    crawler.Log("--------------------------boss start--------------------------------")
    crawler.Log("开始请求 " + company_nameO + " 公司的boss地址，地址为：" + url)
    page.goto(url)
    page.wait_for_timeout(3000)
    page.wait_for_selector(".input-wrap-text")
    company_detail_el = page.locator('div.company-card-wrapper a')
    company_detail_el_count = company_detail_el.count()
    my_obj = {'intro': ""}
    if company_detail_el_count > 0:
        company_detail_el.first.click()
        page.wait_for_timeout(1000)
        page.wait_for_selector("div.info h1.name")
        company_name = page.locator("div.info h1.name").first.inner_text()
        company_intro_el = page.locator("div.job-sec > div.fold-text")
        if company_intro_el.count() > 0:
            company_intro = company_intro_el.first.inner_text()
            if company_name in company_nameO:
                my_obj['intro'] = company_intro

            if company_nameO in company_name:
                my_obj['intro'] = company_intro

        crawler.Log(company_name + " 公司的百科地址上抓取到的数据：" + str(company_intro))
        name2 = crawler.SaveCompanyData(company_nameO, 2, str(company_intro))
        if name2 != "":
            crawler.Log(name2 + " 公司boss数据回传到php 回传成功")
        else:
            crawler.Log(company_nameO + " 公司boss数据回传到php 回传失败")
    else:
        name = crawler.SaveCompanyData(company_nameO, 2, "")
        if name!="":
            crawler.Log(company_nameO + " 公司没有获取到boss数据回传到php 回传成功")
        else:
            crawler.Log(company_nameO + " 公司没有获取到boss数据回传到php 回传失败")

def GetBossCompany(p: Playwright,com_name,boss_url) -> None:
    browser = p.chromium.launch(headless=cyaml.data[cyaml.data["env"]]["headless"])
    context = browser.new_context(viewport={"width": 800, "height": 600})
    js = """
    Object.defineProperties(navigator, {webdriver:{get:()=>undefined}});
    """
    page = context.new_page()
    page.add_init_script(js)
    spider_company(page,com_name,boss_url)

    context.close()
    browser.close()

#爬虫启动
def CrawlerBoss(com_name,boss_url):
    with sync_playwright() as playwright:
        GetBossCompany(playwright,com_name,boss_url)

