from playwright.sync_api import Playwright, sync_playwright, expect

import re
import json
import cyaml
import crawler

#爬虫启动
def CrawlerQqdoc(com_name,url):
    with sync_playwright() as playwright:
        return GetQqdocCompany(playwright,com_name,url)

#爬取百度的数据
def GetQqdocCompany(playwright: Playwright,com_name,url) -> int:
    browser = playwright.chromium.launch(headless=cyaml.data[cyaml.data["env"]]["headless"])
    context = browser.new_context(viewport={"width": 800, "height": 600})
    page = context.new_page()
    name = com_name
    #获取需要爬取数据的公司
    crawler.Log("--------------------------qqdoc start--------------------------------")

    page.goto(url)
    page.wait_for_timeout(8000)
    page.wait_for_selector(".melo-page-container-view")
    # page.locator(".melo-page-container-view").all_text_contents()
    # page.frame_locator("iframe[name=\"login_frame\"]").frame_locator("iframe").get_by_role("link", name="Continue to use in browser").click()
    page.get_by_label("腾讯文档正文内容").press("Meta+a")
    page.get_by_label("腾讯文档正文内容").press("Meta+c")
    all = page.context

    intro = re.sub(r'\[[\d-]+\]', '', str(all))
    crawler.Log(name+" qqdoc上抓取到的数据："+intro)
    if name != "" and intro != '[]':
        intro_new = str(intro[2:len(intro) - 2])
        new_string1 = re.sub(r'\\n', "", intro_new)
        new_string2 = re.sub(r'\\xa0', "", new_string1)

        name2 = crawler.SaveCompanyData(name, 1, new_string2)
        if name2 != "":
            crawler.Log(name2+" qqdoc数据回传到php 回传成功")
            return 100
        else:
            crawler.Log(name + "qqdoc数据回传到php 回传失败")
            return 100
    else:
        crawler.SaveCompanyData(name, 1, "")
        crawler.Log(name +" 公司没有获取到qqdoc数据回传到php 回传成功")
        return 100

    # ---------------------
    context.close()
    browser.close()
    return 100

CrawlerQqdoc("ce","https://doc.weixin.qq.com/doc/w3_AXEAcwZhACknEowzTBmRw6jzHlbf9?scode=AMwA6QetAAYQxyo3EtAcQADQaTAHI")